Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.jxpath.ri.model.beans
Class CollectionPointer

    java.lang.Object
      org.apache.commons.jxpath.ri.model.NodePointer
          org.apache.commons.jxpath.ri.model.beans.CollectionPointer

All Implemented Interfaces:
  Serializable, Cloneable, Comparable, Pointer

Direct Known Subclasses:
  NullElementPointer

    public class CollectionPointer

extends NodePointer

Transparent pointer to a collection (array or Collection).

Version:
  $Revision: 668329 $ $Date: 2008-06-16 16:59:48 -0500 (Mon, 16 Jun 2008) $
Author:
  Dmitri Plotnikov
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer
`index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

Constructor Summary
`CollectionPointer(NodePointer parent, Object collection)` Create a new CollectionPointer.
`CollectionPointer(Object collection, Locale locale)` Create a new CollectionPointer.

Method Summary
`String` | `asPath()` Returns an XPath that maps to this Pointer.
`NodeIterator` | `attributeIterator(QName name)` Returns a NodeIterator that iterates over all attributes of the current node matching the supplied node name (could have a wildcard).
`NodeIterator` | `childIterator(NodeTest test, boolean reverse, NodePointer startWith)` Returns a NodeIterator that iterates over all children or all children that match the given NodeTest, starting with the specified one.
`int` | `compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)` Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
`NodePointer` | `createChild(JXPathContext context, QName name, int index)` Called by a child pointer when it needs to create a parent object for a non-existent collection element.
`NodePointer` | `createChild(JXPathContext context, QName name, int index, Object value)` Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node.
`NodePointer` | `createPath(JXPathContext context)` Called by a child pointer when it needs to create a parent object.
`NodePointer` | `createPath(JXPathContext context, Object value)` Called directly by JXPathContext.
`boolean` | `equals(Object object)`
`Object` | `getBaseValue()` Returns the value represented by the pointer before indexing.
`Object` | `getImmediateNode()` Returns the object the pointer points to; does not convert it to a "canonical" type.
`int` | `getLength()` If the pointer represents a collection (or collection element), returns the length of the collection.
`QName` | `getName()` Returns the name of this node.
`NodePointer` | `getValuePointer()` If this pointer manages a transparent container, like a variable, this method returns the pointer to the contents.
`int` | `hashCode()`
`boolean` | `isCollection()` Returns `true` if the value of the pointer is an array or a Collection.
`boolean` | `isContainer()` If true, this node is auxiliary and can only be used as an intermediate in the chain of pointers.
`boolean` | `isLeaf()` If true, this node does not have children
`NodeIterator` | `namespaceIterator()` Returns a NodeIterator that iterates over all namespaces of the value currently pointed at.
`NodePointer` | `namespacePointer(String namespace)` Returns a NodePointer for the specified namespace.
`void` | `setIndex(int index)` Set the index of this NodePointer.
`void` | `setValue(Object value)` Converts the value to the required type and changes the corresponding object to that value.
`boolean` | `testNode(NodeTest test)` Checks if this Pointer matches the supplied NodeTest.

Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer
`clone, compareTo, createAttribute, escape, getAbstractFactory, getDefaultNamespaceURI, getImmediateParentPointer, getImmediateValuePointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValue, isActual, isAttribute, isDefaultNamespace, isLanguage, isNode, isRoot, newChildNodePointer, newNodePointer, printPointerChain, remove, setAttribute, setNamespaceResolver, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CollectionPointer

    public CollectionPointer(Object collection,
                             Locale locale)

  Create a new CollectionPointer.

  Parameters:
    `collection` - value
    `locale` - Locale

### CollectionPointer

    public CollectionPointer(NodePointer parent,
                             Object collection)

  Create a new CollectionPointer.

  Parameters:
    `parent` - parent NodePointer
    `collection` - value

Method Detail

### getName

    public QName getName()

  Description copied from class: `NodePointer`
  Returns the name of this node. Can be null.

  Specified by:
    `getName` in class `NodePointer`
  Returns:
    QName

### getBaseValue

    public Object getBaseValue()

  Description copied from class: `NodePointer`
  Returns the value represented by the pointer before indexing. So, if the node represents an element of a collection, this method returns the collection itself.

  Specified by:
    `getBaseValue` in class `NodePointer`
  Returns:
    Object value

### isCollection

    public boolean isCollection()

  Description copied from class: `NodePointer`
  Returns `true` if the value of the pointer is an array or a Collection.

  Specified by:
    `isCollection` in class `NodePointer`
  Returns:
    boolean

### getLength

    public int getLength()

  Description copied from class: `NodePointer`
  If the pointer represents a collection (or collection element), returns the length of the collection. Otherwise returns 1 (even if the value is null).

  Specified by:
    `getLength` in class `NodePointer`
  Returns:
    int

### isLeaf

    public boolean isLeaf()

  Description copied from class: `NodePointer`
  If true, this node does not have children

  Specified by:
    `isLeaf` in class `NodePointer`
  Returns:
    boolean

### isContainer

    public boolean isContainer()

  Description copied from class: `NodePointer`
  If true, this node is auxiliary and can only be used as an intermediate in the chain of pointers.

  Overrides:
    `isContainer` in class `NodePointer`
  Returns:
    boolean

### getImmediateNode

    public Object getImmediateNode()

  Description copied from class: `NodePointer`
  Returns the object the pointer points to; does not convert it to a "canonical" type.

  Specified by:
    `getImmediateNode` in class `NodePointer`
  Returns:
    Object node

### setValue

    public void setValue(Object value)

  Description copied from class: `NodePointer`
  Converts the value to the required type and changes the corresponding object to that value.

  Specified by:
    `setValue` in interface `Pointer`
  Specified by:
    `setValue` in class `NodePointer`
  Parameters:
    `value` - the value to set

### setIndex

    public void setIndex(int index)

  Description copied from class: `NodePointer`
  Set the index of this NodePointer.

  Overrides:
    `setIndex` in class `NodePointer`
  Parameters:
    `index` - int

### getValuePointer

    public NodePointer getValuePointer()

  Description copied from class: `NodePointer`
  If this pointer manages a transparent container, like a variable, this method returns the pointer to the contents. Only an auxiliary (non-node) pointer can (and should) return a value pointer other than itself. Note that you probably don't want to override `getValuePointer()` directly. Override the `getImmediateValuePointer()` method instead. The `getValuePointer()` method is calls `getImmediateValuePointer()` and, if the result is not `this`, invokes `getValuePointer()` recursively. The idea here is to open all nested containers. Let's say we have a container within a container within a container. The `getValuePointer()` method should then open all those containers and return the pointer to the ultimate contents. It does so with the above recursion.

  Overrides:
    `getValuePointer` in class `NodePointer`
  Returns:
    NodePointer

### createPath

    public NodePointer createPath(JXPathContext context)

  Description copied from class: `NodePointer`
  Called by a child pointer when it needs to create a parent object. Must create an object described by this pointer and return a new pointer that properly describes the new object.

  Overrides:
    `createPath` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathContext
  Returns:
    created NodePointer

### createPath

    public NodePointer createPath(JXPathContext context,
                                  Object value)

  Description copied from class: `NodePointer`
  Called directly by JXPathContext. Must create path and set value.

  Overrides:
    `createPath` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathContext
    `value` - the new value to set
  Returns:
    created NodePointer

### createChild

    public NodePointer createChild(JXPathContext context,
                                   QName name,
                                   int index,
                                   Object value)

  Description copied from class: `NodePointer`
  Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node. This method may have to expand the collection in order to assign the element.

  Overrides:
    `createChild` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathCOntext
    `name` - the QName at which a child should be created
    `index` - child index.
    `value` - node value to set
  Returns:
    created NodePointer

### createChild

    public NodePointer createChild(JXPathContext context,
                                   QName name,
                                   int index)

  Description copied from class: `NodePointer`
  Called by a child pointer when it needs to create a parent object for a non-existent collection element. It may have to expand the collection, then create an element object and return a new pointer describing the newly created element.

  Overrides:
    `createChild` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathCOntext
    `name` - the QName at which a child should be created
    `index` - child index.
  Returns:
    created NodePointer

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### equals

    public boolean equals(Object object)

  Overrides:
    `equals` in class `Object`

### childIterator

    public NodeIterator childIterator(NodeTest test,
                                      boolean reverse,
                                      NodePointer startWith)

  Description copied from class: `NodePointer`
  Returns a NodeIterator that iterates over all children or all children that match the given NodeTest, starting with the specified one.

  Overrides:
    `childIterator` in class `NodePointer`
  Parameters:
    `test` - NodeTest to filter children
    `reverse` - specified iteration direction
    `startWith` - the NodePointer to start with
  Returns:
    NodeIterator

### attributeIterator

    public NodeIterator attributeIterator(QName name)

  Description copied from class: `NodePointer`
  Returns a NodeIterator that iterates over all attributes of the current node matching the supplied node name (could have a wildcard). May return null if the object does not support the attributes.

  Overrides:
    `attributeIterator` in class `NodePointer`
  Parameters:
    `name` - the attribute name to test
  Returns:
    NodeIterator

### namespaceIterator

    public NodeIterator namespaceIterator()

  Description copied from class: `NodePointer`
  Returns a NodeIterator that iterates over all namespaces of the value currently pointed at. May return null if the object does not support the namespaces.

  Overrides:
    `namespaceIterator` in class `NodePointer`
  Returns:
    NodeIterator

### namespacePointer

    public NodePointer namespacePointer(String namespace)

  Description copied from class: `NodePointer`
  Returns a NodePointer for the specified namespace. Will return null if namespaces are not supported. Will return UNKNOWN_NAMESPACE if there is no such namespace.

  Overrides:
    `namespacePointer` in class `NodePointer`
  Parameters:
    `namespace` - incoming namespace
  Returns:
    NodePointer for `namespace`

### testNode

    public boolean testNode(NodeTest test)

  Description copied from class: `NodePointer`
  Checks if this Pointer matches the supplied NodeTest.

  Overrides:
    `testNode` in class `NodePointer`
  Parameters:
    `test` - the NodeTest to execute
  Returns:
    true if a match

### compareChildNodePointers

    public int compareChildNodePointers(NodePointer pointer1,
                                        NodePointer pointer2)

  Description copied from class: `NodePointer`
  Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.

  Specified by:
    `compareChildNodePointers` in class `NodePointer`
  Parameters:
    `pointer1` - first pointer to be compared
    `pointer2` - second pointer to be compared
  Returns:
    int per Java comparison conventions

### asPath

    public String asPath()

  Description copied from class: `NodePointer`
  Returns an XPath that maps to this Pointer.

  Specified by:
    `asPath` in interface `Pointer`
  Overrides:
    `asPath` in class `NodePointer`
  Returns:
    String xpath expression

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.